   '***********************************************************************
   ' Automatick pankova
   ' v 1.0 (z 26.8.2012)
   '
   ' Automatick nlevna pro 1-7 pank z lahve
   ' Kontrola vychozi polohy, umstn a velikosti pank na otonm talu
   ' kontrola vhy a tm i velikosti obsahu lahve s tekutinou
   ' Akustick upozornn, podsvcen LCD
   ' Monost nastaven z DO protokolu RC-5 Philips
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '
   '***********************************************************************

'pohldat aby pi vysln na LCD nedolo k peruen od kodru !!!

'$sim                                                        ' Odstranit pi programovn - zrychlen simulace
$regfile = "M8def.dat"                                      ' ATmega8
$crystal = 8000000                                          ' 8 MHz - crystal oscillator value

Declare Sub Infra_do()
Declare Sub Menu()
Declare Sub Servomotor()
Declare Sub Vaha()
Declare Sub Zobraz()
Declare Sub Nulovapoloha()
Declare Sub Nalevani()

Config Lcd = 16 * 2                                         'Typ LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0       'Konfigurace pin LCD
Cursor Off

Deflcdchar 0 , 17 , 17 , 17 , 17 , 17 , 31 , 31 , 14
Deflcdchar 2 , 17 , 17 , 31 , 31 , 31 , 31 , 31 , 14
Deflcdchar 3 , 17 , 31 , 31 , 31 , 31 , 31 , 31 , 14
Deflcdchar 1 , 17 , 17 , 17 , 31 , 31 , 31 , 31 , 14

Config Portd = &B00000011                                   'PortD.7 - 2 = in, 1,0 = out (0-in, 1-out)
Config Portc = &B01111111                                   'PortC.7 = in, 6 - 0 = out
Config Portb = &B10111110                                   'PortB.7, 5,4,3,2,1 = out, 0 = in
Podsviceni Alias Portd.0                                    'podsviceni
Piezo Alias Portd.1
Opto Alias Portb.4

Maly Alias Pinb.0
Zastav Alias Pind.7
Zpomal Alias Pind.6
Velky Alias Pind.5
Set Maly                                                    'maly panak (spodni spinac)
Set Zastav                                                  'stuj
Set Zpomal                                                  'zpomal
Set Velky

Config Pind.4 = Input                                       'smrov vstup z Rotacniho koderu
Set Portd.4                                                 'pull-up
Config Int1 = Falling                                       'Konfigurace peruen INT1, reaguj na sestupnou hranu (rot. koder) - PIND.3
Config Int0 = Falling                                       'Konfigurace peruen INT0, reaguj na sestupnou hranu (tlacitko)   - PIND.2
Disable Interrupts                                          'zaka vechna peruen
Enable Int0                                                 'povol peruen INT0
Enable Int1                                                 'povol peruen INT1
On Int1 Koder                                               'obsluha peruen od INT0
On Int0 Tlacitko                                            'obsluha peruen od INT1
Dim Smer As Bit
Dim Hodnota As Byte : Hodnota = 80
Dim Inmenu As Byte
Dim Motor As Bit : Motor = 0

Dim Vydej_panaku As Byte : Vydej_panaku = 0
Dim Vydej_panaku_skutecny As Byte : Vydej_panaku_skutecny = 0
Dim Velikost_panaku As Byte : Velikost_panaku = 1

Dim Pomocna As Byte : Pomocna = 0
Dim Pomocna2 As Byte : Pomocna2 = 0
Dim Procenta_start As Byte
Dim Procenta As Single

Dim Pocet As Byte : Pocet = 0
Dim Panak(7) As Byte

'--------------------- PWM - motor ----------------------
Forw Alias Pwm1a                                            'Oc1a  - Portb.1
Back Alias Pwm1b                                            'Oc1b  - Portb.2
Config Timer1 = Pwm , Prescale = 8 , Compare A Pwm = Clear Up , Pwm = 8 , Compare B Pwm = Clear Up , Pwm = 8
Enable Timer1

Forw = 0
Back = 0

'--------- prijimac dalkoveho ovladani SFH506-36 ---------------
Config Rc5 = Pinb.6 , Timer = 2
Config Pinb.6 = Input
Set Portb.6                                                 'pull-up
Dim Address As Byte
Dim Command As Byte
Enable Timer2


'------------ servo - nalevani ------------
Servo Alias Portb.7
Dim Opak_servo As Byte                                      'opakovani frekvence serva
Dim Poloha As Bit                                           'cas v uS - poloha serva (500 az 2500us)
Poloha = 0                                                  'venti zavreny

'----------- ADC - vaha ------------------
Dim A As Word
Dim X As Single
Dim Gram As Single
Dim Vaha_start As Single
Dim Vaha_stop As Single
Config Adc = Single , Prescaler = Auto , Reference = Avcc


'-------------------------------------------------------------------------------------------------------
Start Timer1
Forw = 0                                                    'zastav motor
Back = 0

'uvodni intro
Set Podsviceni
Cls
   Locate 1 , 1 : Lcd " (c) PaJa-trb"
   Locate 2 , 1 : Lcd "v.1.0  26.8.2012"
   Set Piezo : Waitms 150 : Reset Piezo
Wait 1
Cls
   Locate 1 , 1 : Lcd "  Automaticky"
   Locate 2 , 1 : Lcd "   panakovac"
Waitms 500

Enable Interrupts

Poloha = 0                                                  'poloha serva 0 - tedy zavreny ventil
Gosub Servomotor                                            'bez na servo a zavri ventil

'---------- vlastn program - smyka ------------------

Do

   Gosub Vaha                                               'zkontroluj vhu
   If Gram < 65 Then Goto Sahara                            'kdyz je mala vaha - tak konec - dolej

   Gosub Infra_do                                           'zkontroluj DO
   If Vydej_panaku <> 0 Then Gosub Nalevani                 'pokud jsou zadane panaky k vydeji tak je bez nalit

   Waitms 10

Loop

End

'-----------------------------------------------------


Sub Zobraz()
   Disable Interrupts
   Cls
   Select Case Panak(pomocna)
      Case 0:
               Locate 1 , 1 : Lcd "Panak" ; Pomocna ; "= zadny "
      Case 1:
               Locate 1 , 1 : Lcd "Panak" ; Pomocna ; "= maly "
      Case 11:
               Locate 1 , 1 : Lcd "Panak" ; Pomocna ; "= velky "
   End Select

   Locate 2 , 1 : Lcd "Ma dat=" ; Vydej_panaku ; ", dal=" ; Vydej_panaku_skutecny

   Enable Interrupts
End Sub



'------------------------ najdi nulovou pozici ---------------------------------
Sub Nulovapoloha()

Disable Interrupts
   Cls
   Locate 1 , 1 : Lcd "Hledam vychozi"
   Locate 2 , 1 : Lcd "pozici..."

If Zpomal = 1 And Zastav = 1 Then Goto Nulanalezena         'pokud stoji na nulove pozici, tak nic nedlej
   Opak_servo = 0
   Back = 0
   Forw = 120
   Waitms 100

Do
   Waitms 25
   If Zpomal = 0 Then Opak_servo = 0                        'kdyz sjel tak vynuluj delku
   If Zpomal = 1 Then Incr Opak_servo                       'po najeti na zpomaleni pocitej jeho delku
   If Opak_servo > 13 Then Forw = 70                        'najel na dlouhy zpomaleni, tak sniz rychlost
Loop Until Zpomal = 1 And Zastav = 1                        'nulova pozice jsou oba snmae zrove aktivn
   Forw = 0                                                 'a zastav

Nulanalezena:
   Locate 2 , 1 : Lcd "pozici... OK    "
   Wait 1

Enable Interrupts

End Sub

'----------------------- proces pripravy nalevani panaku --------------------------------------

Sub Nalevani()

Gosub Nulovapoloha

Pomocna = 1
Do
   Gosub Infra_do                                           'kontroluj povely z DO
      Panak(pomocna) = 0
   If Maly = 1 And Velky = 0 Then Panak(pomocna) = 1        'maly panak
   If Maly = 1 And Velky = 1 Then Panak(pomocna) = 11       'velky panak
   If Panak(pomocna) = 0 Then
      Locate 1 , 1 : Lcd "   Neni panak !  "
      Set Piezo : Waitms 200 : Reset Piezo : Waitms 500
   End If

   Gosub Zobraz

   If Panak(pomocna) = 1 And Velikost_panaku < 3 Then Goto Nalej
   If Panak(pomocna) = 1 And Velikost_panaku > 2 Then
      Locate 1 , 1 : Lcd "   Maly panak !  "
      Set Piezo : Waitms 300 : Reset Piezo : Waitms 500
   End If

   If Panak(pomocna) = 11 Then Goto Nalej

   Gosub Zobraz
Zpetnalevani:
   Gosub Zobraz

      Incr Pomocna                                          'neni-li panak tak skoc dal
      Forw = 120
      Waitms 400

      Do : Nop : Loop Until Zpomal = 1 : Forw = 80          'cekej dokud nenajede na zpomaleni a zpomal rychlost
      Do : Nop : Loop Until Zastav = 1 :
         Do
            Waitms 25
         Loop Until Zastav = 0 Or Maly = 1                  'cekej dokud nebude njak pank nebo nesjede ze zastav. snimace
         Waitms 50
      Forw = 0

   If Pomocna = 8 And Vydej_panaku_skutecny <> Vydej_panaku Then
      Locate 1 , 1 : Lcd "Malo panaku !"
      Locate 2 , 1 : Lcd "vypij to a dopln"
      Set Piezo : Waitms 300 : Reset Piezo : Wait 2

      Do : Nop : Loop Until Inmenu > 3
      Goto Doplnpanakyvdalsimkole
   End If

   Gosub Zobraz
   Wait 1

Loop Until Vydej_panaku_skutecny = Vydej_panaku Or Pomocna = 8

If Vydej_panaku_skutecny = Vydej_panaku Then
   Vydej_panaku = 0
   Disable Interrupts
   Cls
   Locate 1 , 1 : Lcd "Mas nalito, dej"
   Locate 2 , 1 : Lcd "si do nosa  :-)"
   Set Piezo : Waitms 100 : Reset Piezo : Waitms 250
   Set Piezo : Waitms 200 : Reset Piezo : Waitms 250
   Set Piezo : Waitms 400 : Reset Piezo : Wait 1
   Enable Interrupts
End If

   Vydej_panaku_skutecny = 0

Doplnpanakyvdalsimkole:
   Pomocna = 1

End Sub

'------------------- samotne nalevani -------------------------------------

Nalej:
   Incr Vydej_panaku_skutecny

   Waitms 100
   Gosub Vaha
   Vaha_start = Gram                                        'uloz vahu pred zacatkem nalevani

   Waitms 300

   Select Case Gram                                         'prepocet casu nalevani podle hmotnosti tekutiny
      Case Is < 65 : Goto Sahara                            'mlo tekutiny - zastav a dopln
      Case 65 To 120 : Pomocna2 = 24
      Case 120 To 200 : Pomocna2 = 20
      Case 200 To 300 : Pomocna2 = 17
      Case 300 To 400 : Pomocna2 = 14
      Case 400 To 500 : Pomocna2 = 12
      Case 500 To 600 : Pomocna2 = 10
      Case 600 To 700 : Pomocna2 = 8
      Case 700 To 800 : Pomocna2 = 6
      Case 800 To 900 : Pomocna2 = 4
      Case Is > 900 : Pomocna2 = 3
   End Select

   Poloha = 1                                               'otevri servo - nalej
   Gosub Servomotor

   Select Case Velikost_panaku
      Case 1 : Vaha_stop = Vaha_start - 9
      Case 2 :
               Pomocna2 = Pomocna2 + 16
               Vaha_stop = Vaha_start - 18
      Case 3 :
               Pomocna2 = Pomocna2 + 35
               Vaha_stop = Vaha_start - 28
      Case 4 :
               Pomocna2 = Pomocna2 + 53
               Vaha_stop = Vaha_start - 36
   End Select

      Procenta_start = Pomocna2

   Do
      Decr Pomocna2
      Gosub Vaha
      Gosub Infra_do
      If Gram < Vaha_stop Then Pomocna2 = 0                 'pojistka, pokud dojde k poklesu vahy driv nez odpocet pomocna2
      If Gram < 65 Then Goto Sahara                         'malo piti, pak uz nelze nalevat

      Disable Interrupts
         Locate 1 , 1 : Lcd "Lahev=" ; Gram
         Locate 1 , 10 : Lcd "ml     "

         Procenta = Pomocna2 / Procenta_start
         Procenta = Procenta * 100
   '      Opak_servo = Int(procenta)                           'vrac celeou cast promenne (na toto uz ale neni misto v procesoru)
         Locate 2 , 1 : Lcd "Zbyva nalit=" ; Procenta
         Locate 2 , 15 : Lcd "%       "
   '      Locate 2 , 1 : Lcd "stop=" ; Vaha_stop ; "  "
   '      Locate 2 , 11 : Lcd " c=" ; Pomocna2 ; "   "
      Enable Interrupts

   Loop Until Pomocna2 = 0 Or Command = 87                  'neskonci-li odpocet, nebo neni-li zastaveno tlac OK z DO

   Poloha = 0                                               'zavri servo
   Gosub Servomotor
   Waitms 500

Goto Zpetnalevani

Return

'--------------- sahara - doslo piti ------------

Sahara:
   Poloha = 0
   Gosub Servomotor
   Vydej_panaku_skutecny = 0                                'zrus vsechny nelejvani
   Vydej_panaku = 0

   Disable Interrupts
   Cls
   Locate 1 , 1 : Lcd "! Dosly zasoby !"
   Locate 2 , 1 : Lcd "   ! SAHARA !"
   Set Piezo : Waitms 300 : Reset Piezo : Wait 1
   Set Piezo : Waitms 500 : Reset Piezo : Wait 2

   Locate 2 , 1 : Lcd "dolej a potvrd  "

   Do
      Gosub Vaha
      Locate 1 , 1 : Lcd "Tekutin je " ; Gram ; "  "
      Waitms 25
   Loop Until Gram > 100 And Pind.2 = 0

   Enable Interrupts
Return


'-------------------- vaha --------------------------
'zvazi 50x, vypocita prumer a prevede na gramy
Sub Vaha()

   Start Adc
     Opak_servo = 0
     X = 0
     Do
        A = Getadc(7)                                       'nacti hodontu z interniho AD
        X = X + A                                           'pripocitej hodnotu
        Incr Opak_servo
        Waitms 2
     Loop Until Opak_servo = 50
   Stop Adc

   X = X / 50                                               'prumerna hodnota
   X = X - 361                                              'odest nulu (hmotnost prazdne flasky a police)
   Gram = X * 17.86                                         'prepocet na gramy

End Sub

'------------------------ servo -----------------------------------------------------

'ovlada ventil nalivani 1-0
Sub Servomotor()
   Opak_servo = 0                                           'pomocna pro odpocty

If Poloha = 0 Then                                          'close
   Do
      Set Servo : Waitus 600
      Reset Servo : Waitms 20
      Opak_servo = Opak_servo + 1
   Loop Until Opak_servo = 30
End If

If Poloha = 1 Then                                          'open
   Do
      Set Servo : Waitus 1550
      Reset Servo : Waitms 20
      Opak_servo = Opak_servo + 1
   Loop Until Opak_servo = 30
End If

End Sub

'---------------------------------- Obsluha rotanho koderu -------------------------------------------------------
Koder:

Smer = Pind.4                                               'zjisti hodnotu smeroveho vstupu z koderu

If Smer = 1 Then                                            'pokud je smr oten vpravo tak
   If Hodnota < 140 Then
      Hodnota = Hodnota + 10                                'piti 1 k nastaven
   End If
Elseif Smer = 0 Then                                        'pokud je smr oten vlevo tak
   If Hodnota > 10 Then
      Hodnota = Hodnota - 10                                'odeti 1 od nastaven
   End If
End If

   Cls
   Locate 1 , 1 : Lcd "Rucni posuv"
If Hodnota > 60 Then
   Forw = Hodnota                                           'jed po smeru hodin. rucicek
   Back = 0
   Inmenu = Hodnota / 10
   Inmenu = Inmenu - 6
   Locate 2 , 1 : Lcd "Doprava +" ; Inmenu ; "  "
Elseif Hodnota < 60 Then
   Forw = 0
   Back = Hodnota + 70                                      'jed proti smeru hodin. rucicek
   Inmenu = Hodnota / 10
   Locate 2 , 1 : Lcd "Doleva  -" ; Inmenu ; "  "
Elseif Hodnota = 60 Then
   Forw = 0 : Back = 0                                      'stuj
   Locate 2 , 1 : Lcd "Stuj          "
End If

Waitms 1

Return                                                      'nvrat z peruen

'-------------------------------------------------------------------------------------------------------------------

'---------------------------------- Obsluha stisku tlacitka --------------------------------------------------------
Tlacitko:

Cls
Waitms 10

Forw = 0                                                    'zastav motor
Back = 0                                                    'zastav motor

'sleduj dlku stisku tlacitka, je-li delsi nez 600ms, vstup do menu
If Pind.2 = 0 Then
   Inmenu = 0
   Do
      Incr Inmenu
      Waitms 20
      If Inmenu >= 30 Then                                  'je-li hodnota vetsi tak skoc do menu
         Gosub Menu
      End If
   Loop Until Pind.2 = 1                                    'opakuj dokud neni tlacitko pusteno
End If

If Inmenu < 30 Then                                         'trval-li stisk pod 200ms prepni normal/standby
  Locate 1 , 1 : Lcd "Kratky stisk,  "
  Locate 2 , 1 : Lcd "do menu delsi..."
End If

Return


'-------------------------------------------------------------------------------


Sub Menu
Inmenu = 0

Set Podsviceni
Disable Int1                                                'zaka extern peruen INT1 (enkoder)
Disable Int0                                                'zaka extern peruen INT0 (tlacitko)

   Cls
   Locate 1 , 1 : Lcd "Menu - nastaveni"
   Waitms 500

'------------ pocet panaku ------------
   Locate 1 , 1 : Lcd "Kolik panaku ?  "
   Locate 2 , 1 : Lcd "zadej: " ; Vydej_panaku ; "   [1-7]"
   If Vydej_panaku < 1 Then Vydej_panaku = 1                'aby nedoslo k potvrzeni nuloveho mnozstvi

   Do
      Locate 2 , 8 : Lcd Vydej_panaku ; " "
      If Pind.3 = 0 Then
         Smer = Pind.4                                      'zjisti hodnotu smeroveho vstupu z koderu
         Bitwait Pind.3 , Set

         If Smer = 1 Then
            Vydej_panaku = Vydej_panaku + 1
         Else
            Vydej_panaku = Vydej_panaku - 1
         End If
         If Vydej_panaku < 1 Then Vydej_panaku = 1
         If Vydej_panaku > 7 Then Vydej_panaku = 7
      End If
      Waitms 10
   Loop Until Pind.2 = 0                                    'opakuj dokud neni stisknute tlacitko koderu nebo tkac. OK na DO

   Locate 2 , 12 : Lcd "   OK"
   Waitms 500
'------------ / pocet panaku ------------


'------------ obsah panaku ------------
   Cls
   Locate 1 , 1 : Lcd "Kolik nacepovat? "

   Do
      Select Case Velikost_panaku
         Case 1 :
            Locate 2 , 1 : Lcd "1 cl - detsky  " ; Chr(0)
         Case 2 :
            Locate 2 , 1 : Lcd "2 cl - maly    " ; Chr(1)
         Case 3 :
            Locate 2 , 1 : Lcd "3 cl - stredni " ; Chr(2)
         Case 4 :
            Locate 2 , 1 : Lcd "4 cl - velky   " ; Chr(3)
      End Select

      If Pind.3 = 0 Then
         Smer = Pind.4                                      'zjisti hodnotu smeroveho vstupu z koderu
         Bitwait Pind.3 , Set

         If Smer = 1 Then
            Velikost_panaku = Velikost_panaku + 1
            If Velikost_panaku > 4 Then Velikost_panaku = 4
         Elseif Smer = 0 Then
            Velikost_panaku = Velikost_panaku - 1
            If Velikost_panaku < 1 Then Velikost_panaku = 1
         End If
      End If

      Waitms 15
   Loop Until Pind.2 = 0                                    'opakuj dokud neni stisknute tlacitko

   Locate 2 , 14 : Lcd " OK"
   Waitms 500
   Cls
'------------ / pocet panaku ------------

Enable Int1
Enable Int0


End Sub


'-------------------------------------------------------------------------------


Sub Infra_do()

   Command = 0
   Getrc5(address , Command)
   Command = Command And &B01111111

'nastaveni menu jen z DO
If Command = 82 Then

   Disable Int1                                             'zaka extern peruen INT1 (enkoder)
   Disable Int0                                             'zaka extern peruen INT0 (tlacitko)

   Cls
   Locate 1 , 1 : Lcd "Menu - nastaveni"
   Waitms 500

'------------ pocet panaku ------------
   Locate 1 , 1 : Lcd "Kolik panaku ?  "
   Locate 2 , 1 : Lcd "zadej: " ; Vydej_panaku ; "   [1-7]"
   If Vydej_panaku < 1 Then Vydej_panaku = 1                'aby nedoslo k potvrzeni nuloveho mnozstvi

   Do
      Locate 2 , 8 : Lcd Vydej_panaku ; " "

      Command = 0
      Getrc5(address , Command)
      Command = Command And &B01111111

      If Command > 0 And Command < 8 Then                   'prime zadani poctu panaku z klavesnice cisel (je-li pocet mezi 1-7)
         Vydej_panaku = Command
      End If

   Loop Until Command = 87                                  'opakuj dokud neni stisknute tlacitko koderu nebo tkac. OK na DO

   Locate 2 , 12 : Lcd "   OK"
   Waitms 500
'------------ / pocet panaku ------------


'------------ obsah panaku ------------
   Cls
   Locate 1 , 1 : Lcd "Kolik nacepovat? "

   Do
      Select Case Velikost_panaku
         Case 1 :
            Locate 2 , 1 : Lcd "1 cl - detsky  " ; Chr(0)
         Case 2 :
            Locate 2 , 1 : Lcd "2 cl - maly    " ; Chr(1)
         Case 3 :
            Locate 2 , 1 : Lcd "3 cl - stredni " ; Chr(2)
         Case 4 :
            Locate 2 , 1 : Lcd "4 cl - velky   " ; Chr(3)
      End Select

      Command = 0
      Getrc5(address , Command)
      Command = Command And &B01111111

         If Command = 16 Then
            Incr Velikost_panaku
            If Velikost_panaku > 4 Then Velikost_panaku = 4
         Elseif Command = 17 Then
            Decr Velikost_panaku
            If Velikost_panaku < 1 Then Velikost_panaku = 1
         End If

         If Command > 0 And Command < 5 Then                'prime zadani poctu panaku z klavesnice cisel (je-li pocet mezi 1-7)
            Velikost_panaku = Command
         End If

      Waitms 75
   Loop Until Command = 87                                  'opakuj dokud neni stisknute tlacitko

   Locate 2 , 14 : Lcd " OK"
   Waitms 500
'------------ / pocet panaku ------------

   Enable Int1
   Enable Int0

End If

'testovaci - pro manualni ovladani servoventilu z DO
'   If Command = 16 Then
'      Poloha = 0 : Gosub Servomotor
'   End If
'   If Command = 17 Then
'      Poloha = 1 : Gosub Servomotor
'   End If

End Sub

' (c) PaJa-trb 2012